#include <iostream>
#include "classes.h"

using namespace std;

void UzemanyagTank::uzemanyagotFogyaszt(double m)
{
    if(m<=0) throw RosszMennyiseg;
    aktMennyiseg-=m;
    if(aktMennyiseg<0) aktMennyiseg=0;
}


Jarmu::Jarmu(double fogy, int tkap, Szin s, double umenny, double ukap):
    tank(umenny,ukap), szine(s), fogyasztas(fogy), termekKapacitas(tkap)
{
    if(fogyasztas <= 0) throw RosszFogyasztas;
    if(tkap <= 0) throw RosszTermekKapacitas;
    akt=0;
}

bool Jarmu::eleg_az_uzemanyag(double dist)
{
    if (dist<0) throw RosszTavolsag;
    double smenny=dist*fogyasztas/100;
    return smenny<=tank.getUzemanyag();
}

void Jarmu::menet(double d)
{
    if(d<0) throw RosszTavolsag;
    double aktfogy=d*fogyasztas/100;
    if(aktfogy>tank.getUzemanyag()) throw TankolniKell;
    tank.uzemanyagotFogyaszt(aktfogy);
}

void Jarmu::tolt(double menny)
{
    if(menny<0) throw RosszMennyiseg;
    if(tank.getUzemanyag()+menny>tank.getKapacitas()) throw Tultoltes;
    tank.uzemanyagotTolt(menny);
}

bool Jarmu::felveszTermek(Termek t)
{
    if((int)rakomany.size()<termekKapacitas)
    {
        rakomany.push_back(t);
        return true;
    }else{
        cerr<<"Megtelt a kocsi!\n";
        return false;
    }
}

Termek Jarmu::atadTermek()
{
    Termek t=rakomany[akt];
    akt++;
    return t;
}

int Jarmu::kovTavHossz()
{
    if(akt<(int)rakomany.size())
    {
        return rakomany[akt].getCelTav();
    }else{
        return -1;
    }
}

void Futar::szallit(const std::vector<Termek>& termekek)
{
    cout<<"Bepakolas\n";
    cout<<"Bepakolt termekek:\n";
    bool tele=false;
    for(int i=0; !tele && i<(int)termekek.size();++i)
    {
        tele=!kocsi->felveszTermek(termekek[i]);
        if(!tele)
        {
            cout<<i+1<<". termek:"<<termekek[i].getCim()<<endl;
        }
    }
    if(tele)
    {
        cout<<"Nem fer tobb a kocsiba!\n";

    }
    cout<<"Indulas\n";
    cout<<"Uzemanyag mennyisege indulaskor:"<<kocsi->getAktTank()<<endl;
    Termek t; int sorsz=0;
    while(kocsi->kovTavHossz()>0) //amig van a kocsiban termek
    {
        ++sorsz;
        t=kocsi->atadTermek();
        cout<<endl<<sorsz<<". termek szallitasa\n";
        if(!kocsi->eleg_az_uzemanyag(t.getCelTav()))
        {
            cout<<"Tankolni kell.\n";
            double tmenny=kocsi->getTankKapacitas()-kocsi->getAktTank();
            kocsi->tolt(tmenny);
            cout<<"Tankolt mennyiseg:"<<tmenny<<endl;
            if(!kocsi->eleg_az_uzemanyag(t.getCelTav()))
               {
                   cerr<<"Sajnos nem szallithato ki a termek, kicsi a tank kapacitas!\n";
                   cerr<<"Cim: "<<t.getCim()<<" "<<" tavolsag: "<<t.getCelTav()<<endl;
                   cerr<<"Megprobaljuk a kovetkezo termeket kiszallitani.\n";
                   continue;
               }
        }else{
            cout<<"Nem kell tankolni.\n";
        }
            kocsi->indits(); double tank1=kocsi->getAktTank();
            cout<<"Elindult a kocsi.\n";

            kocsi->menet((double)t.getCelTav());
            cout<<"Megy a kocsi, tavolsag:"<<t.getCelTav()<<endl;

            kocsi->allj(); double tank2=kocsi->getAktTank();
            cout<<"Kocsi megerkezett, elfogyasztott benzin:"<<tank1-tank2<<endl;

            cout<<"Aru leadva: "<<t.getCim()<<endl;

            cout<<"Uzemanyag mennyiseg:"<<kocsi->getAktTank()<<endl;

    }
}
